﻿using System;
using System.Collections.Specialized;
using System.Text;

namespace TwitterApi
{
    public class StringUtil
    {

        protected static string unreservedChars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_.~";

        /// <summary>
        /// This is a different Url Encode implementation since the default .NET one outputs the percent encoding in lower case.
        /// While this is not a problem with the percent encoding spec, it is used in upper case throughout OAuth
        /// </summary>
        /// <param name="value">The value to Url encode</param>
        /// <returns>Returns a Url encoded string</returns>
        public static string UrlEncode(string value)
        {
            StringBuilder result = new StringBuilder();

            foreach (char symbol in value)
            {
                if (unreservedChars.IndexOf(symbol) != -1)
                {
                    result.Append(symbol);
                }
                else
                {
                    result.Append('%' + String.Format("{0:X2}", (int)symbol));
                }
            }

            return result.ToString();
        }

        /// <summary>
        /// TBI
        /// </summary>
        /// <param name="?"></param>
        /// <returns></returns>
        public static string UrlDecode(string s)
        {
            string ret = "";
            for (int i = 0; i < s.Length; i++)
            {
                if (s[i] == '%')
                {
                    string hex = "" + s[i + 1] + s[i + 2];
                    // Convert the number expressed in base-16 to an integer.
                    int value = Convert.ToInt32(hex, 16);
                    // Get the character corresponding to the integral value.
                    char c = (char)value;
                    ret += c;
                    i += 2;
                }
                else ret += s[i];
            }
            return ret;
        }


        public static NameValueCollection ParseQueryString(string response)
        {
            var nc = new NameValueCollection();
            string q = response;
            if (response.Contains("?"))
            {
                int ix = response.IndexOf("?");
                if (response.Length > ix+1)  q = response.Substring(ix + 1);
                else return nc; // empty params
            }
            string[] split = q.Split('&');
            foreach (var elem in split)
            {
                string[] nameVal = elem.Split('=');
                if (nameVal.Length == 2)
                    nc.Add(nameVal[0], nameVal[1]);
            }
            return nc;
        }
    }
}
