﻿using System;
using System.Diagnostics;
using System.Windows.Forms;
using TwitterApi;

namespace OauthTester
{
    public partial class TestForm : Form
    {
        private oAuthTwitter _oAuth;
        private string _oAuthToken;
        private string _url;

        public TestForm()
        {
            InitializeComponent();
            _oAuth = new oAuthTwitter();
            _oAuth.ConsumerKey = ""; // Your key here
            _oAuth.ConsumerSecret = ""; // YOur secret here
        }

        private void GetUrlButton_Click(object sender, EventArgs e)
        {

            try
            {
                 _url = _oAuth.AuthorizationLinkGet(out _oAuthToken);
                ServerLink.Text = "Click me";
                AuthTokenTextBox.Text = _oAuthToken;
            }
            catch (Exception ex)
            {
                WriteException(ex);
            }
        }

        private void VerifyButton_Click(object sender, EventArgs e)
        {

            try
            {
                _oAuth.AccessTokenGet(_oAuthToken, PinTextBox.Text);
                // This is the key you save for reauthentication in a later session
                AccessTokenTextBox.Text = _oAuth.TokenSecret; 
            }
            catch (Exception ex)
            {

                WriteException(ex);
            }
        }
        private void WriteException(Exception ex)
        {
            ErrorTextBox.Text = ex.Message + Environment.NewLine + ex.StackTrace;
        }

        private void ServerLink_Click(object sender, EventArgs e)
        {
            if (_url != null)
                Process.Start(_url, "");
        }
    }
}